#
# spec file for package mozilla-xulrunner (Version 1.8.0.1)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    Mesa Mesa-devel aaa_base acl alsa alsa-devel atk atk-devel attr audiofile audiofile-devel audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 cairo cairo-devel coreutils cpio cpp cracklib cvs cyrus-sasl db dbus-1 dbus-1-devel dbus-1-glib desktop-translations diffutils e2fsprogs esound esound-devel expat expat-32bit file filesystem fillup findutils flex fontconfig fontconfig-32bit fontconfig-devel freetype2 freetype2-32bit freetype2-devel gawk gcc gcc-c++ gconf2 gconf2-devel gdbm gdbm-devel gettext gettext-devel glib2 glib2-devel glibc glibc-32bit glibc-devel glibc-locale glitz glitz-devel gnome-filesystem gnome-keyring gnome-keyring-devel gnome-vfs2 gnome-vfs2-devel gpm grep groff gtk2 gtk2-devel gzip hal hal-devel info insserv java-1_4_2-sun java-1_4_2-sun-devel jpackage-utils klogd less libacl libart_lgpl libart_lgpl-devel libattr libbonobo libbonobo-devel libbonoboui libbonoboui-devel libcom_err libdrm libgcc libglade2 libgnome libgnome-devel libgnomecanvas libgnomecanvas-devel libgnomeui libgnomeui-devel libidl libidl-devel libjpeg libjpeg-devel libnscd libpng libpng-devel libstdc++ libstdc++-devel libtool libusb libxcrypt libxml2 libxml2-devel libzio m4 mDNSResponder-lib make man mktemp module-init-tools mozilla-nspr mozilla-nspr-devel mozilla-nss mozilla-nss-devel ncurses ncurses-devel net-tools netcfg openldap2-client openmotif-libs openssl openssl-devel orbit2 orbit2-devel pam pam-modules pango pango-devel patch perl permissions pkgconfig popt popt-devel procinfo procps psmisc pwdutils rcs readline resmgr rpm sed strace sysvinit tar tcpd texinfo timezone unzip update-alternatives update-desktop-files util-linux vim xorg-x11-devel xorg-x11-libs xorg-x11-libs-32bit zip zlib zlib-32bit zlib-devel

Name:           mozilla-xulrunner
BuildRequires:  gcc-c++ java-1_4_2-sun-devel libgnomeui-devel libidl-devel mozilla-nss-devel update-alternatives update-desktop-files zip
License:        MPL, GPL
Version:        1.8.0.1
Release:        32.2
Summary:        Mozilla Runtime Environment
URL:            http://www.mozilla.org/
Group:          Productivity/Networking/Web/Browsers
Provides:       gecko
Provides:       mozilla-xulrunner18
Source:         xulrunner-source-%{version}.tar.bz2
Patch0:         system-nspr.patch
Patch1:         abuild.patch
Patch2:         nss-opt.patch
Patch3:         visibility.patch
Patch4:         idldir.patch
Patch5:         pango-cairo.patch
Patch6:         system-prefs.patch
Patch7:         nsISidebar.patch
Patch8:         nsIPermission.patch
Patch9:         rpath.patch
Patch10:        system-nss.patch
Patch11:        system-proxies.patch
Patch12:        xulrunner-1.8.0.2.patch.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
PreReq:         libstdc++ expat pango xorg-x11-libs fontconfig freetype2
PreReq:         gtk2 atk glib2
### build configuration ###
%define has_system_cairo 0
%define has_system_nspr  0
%define has_system_nss   0
%define pango 0
%if %suse_version > 930 || %is_plus
%define has_system_cairo 1
%define has_system_nspr  1
%endif
%if %is_plus || %suse_version >= 930
%define pango 1
%endif
%if %suse_version > 1000 || %is_plus
%define has_system_nss   1
%endif
%define releasedate 2006031100
### configuration end ###
%define my_provides /tmp/my-provides
%define my_requires /tmp/my-requires
%if %has_system_nspr
PreReq:         mozilla-nspr >= %( echo `rpm -q --queryformat '%{VERSION}' mozilla-nspr`)
%endif
%if %has_system_nss
PreReq:         mozilla-nss >= %( echo `rpm -q --queryformat '%{VERSION}' mozilla-nss`)
%endif

%description
XULRunner is a single installable package that can be used to bootstrap
multiple XUL+XPCOM applications that are as rich as Firefox and
Thunderbird.



Authors:
--------
    Mozilla Foundation <drivers@mozilla.org>

%debug_package
%package -n gecko-sdk
Summary:        SDK for the Gecko Runtime
Group:          Productivity/Networking/Web/Browsers
Provides:       gecko-devel
Provides:       gecko18
%if %has_system_nspr
Requires:       mozilla-nspr-devel >= %( echo `rpm -q --queryformat '%{VERSION}' mozilla-nspr-devel`) 
%endif
%if %has_system_nss
PreReq:         mozilla-nss-devel >= %( echo `rpm -q --queryformat '%{VERSION}' mozilla-nss-devel`)
%endif
PreReq:         %{name} = %{version}

%description -n gecko-sdk
Software Development Kit to embed XUL or Gecko into other applications.



Authors:
--------
    Mozilla Foundation <drivers@mozilla.org>

%prep
%setup -n mozilla -q
%if %has_system_nspr
%patch0
%endif
%if %has_system_cairo
%patch5
%endif
%patch1
%patch2
%patch3
%patch4
%patch6
%patch7
%patch8
%patch9
%if %has_system_nss
%patch10
%endif
%patch11
%patch12 -p1

%build
export MOZ_BUILD_DATE=%{releasedate}
export LD_LIBRARY_PATH=$RPM_BUILD_DIR/mozilla/dist/bin
export CFLAGS="$RPM_OPT_FLAGS -Os -fno-strict-aliasing"
%if %suse_version > 1000
export CFLAGS="$CFLAGS -fstack-protector"
%endif
export CXXFLAGS="$CFLAGS"
export RPATH="-Wl,-rpath -Wl,%{_libdir}/xulrunner-%{version}"
export MOZCONFIG=$RPM_BUILD_DIR/mozconfig
export MOZILLA_OFFICIAL=1
export BUILD_OFFICIAL=1
#
cat << EOF > $MOZCONFIG
mk_add_options MOZILLA_OFFICIAL=1
mk_add_options BUILD_OFFICIAL=1
mk_add_options MOZ_MAKE_FLAGS=%{?jobs:-j%jobs}
. \$topsrcdir/xulrunner/config/mozconfig
ac_add_options --prefix=%{_prefix}
ac_add_options --libdir=%{_libdir}
ac_add_options --sysconfdir=%{_sysconfdir}
ac_add_options --mandir=%{_mandir}
ac_add_options --includedir=%{_includedir}
ac_add_options --enable-optimize="$CFLAGS"
ac_add_options --with-system-jpeg
ac_add_options --with-system-png
ac_add_options --with-system-mng
ac_add_options --with-system-zlib
ac_add_options --enable-default-toolkit=gtk2
ac_add_options --enable-xft
ac_add_options --disable-freetype2
ac_add_options --enable-svg
ac_add_options --enable-canvas
ac_add_options --disable-tests
ac_add_options --disable-installer
EOF
%if %pango
cat << EOF >> $MOZCONFIG
ac_add_options --enable-pango
EOF
%endif
%if %has_system_nspr
cat << EOF >> $MOZCONFIG
ac_add_options --with-system-nspr
EOF
%endif
%if %has_system_nss
cat << EOF >> $MOZCONFIG
ac_add_options --with-system-nss
EOF
%endif
%if %has_system_cairo
cat << EOF >> $MOZCONFIG
ac_add_options --enable-system-cairo
EOF
%endif
make -f client.mk build

%install
make -C xulrunner/installer STRIP=/bin/true
mkdir -p $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{version}
mkdir -p $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{version}/extensions
mkdir -p $RPM_BUILD_ROOT/usr/bin
cp -rf dist/xulrunner/* $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{version}/
ln -sf ../%{_lib}/xulrunner-%{version}/xulrunner $RPM_BUILD_ROOT%{_bindir}/
# GRE
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/gre.d/
# SDK
mkdir -p $RPM_BUILD_ROOT%{_includedir}/xulrunner-%{version}
mkdir -p $RPM_BUILD_ROOT%{_libdir}/pkgconfig
mkdir -p $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{version}/bin/
cp -rL dist/sdk/bin/*     $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{version}/
cp -rL dist/sdk/lib/*.a   $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{version}/
cp -rL dist/sdk/idl/*     $RPM_BUILD_ROOT%{_includedir}/xulrunner-%{version}/
cp -rL dist/include/*     $RPM_BUILD_ROOT%{_includedir}/xulrunner-%{version}/
cp -rL dist/sdk/include/* $RPM_BUILD_ROOT%{_includedir}/xulrunner-%{version}/
cp -rL dist/bin/xulrunner-config  $RPM_BUILD_ROOT%{_bindir}/
install -m 755 $RPM_BUILD_DIR/mozilla/build/unix/xulrunner-*.pc $RPM_BUILD_ROOT%{_libdir}/pkgconfig/
# XPI example
cp -rL dist/xpi-stage/simple $RPM_BUILD_ROOT/%{_libdir}/xulrunner-%{version}/
# ghosts
touch $RPM_BUILD_ROOT/%{_libdir}/xulrunner-%{version}/global.reginfo
%if %has_system_nspr && !%has_system_nss
# modify provides and requires lists
cat << EOF > %{my_provides}
grep -vE "libnss3.so|libnssckbi.so|libsmime3.so|libsoftokn3.so|libssl3.so" | %{__find_provides}
EOF
chmod 755 %{my_provides}
%define __find_provides %{my_provides}
cat << EOF > %{my_requires}
grep -vE "libnss3.so|libnssckbi.so|libsmime3.so|libsoftokn3.so|libssl3.so|xulrunner-bin" | %{__find_requires}
EOF
chmod 755 %{my_requires}
%define __find_requires %{my_requires}
%endif

%clean
rm -rf $RPM_BUILD_ROOT
%if %has_system_nspr && !%has_system_nss
rm -f %{my_provides}
rm -f %{my_requires}
%endif

%pre
# if an update we need to unregister now
if [ "$1" = "2" ]; then
  %{_bindir}/xulrunner --unregister-global 
fi
exit 0

%post
%{_bindir}/xulrunner --register-global || :

%preun
if [ "$1" = "0" ]; then # deinstallation
  %{_bindir}/xulrunner --unregister-global
fi
exit 0

%files
%defattr(-,root,root)
%dir %{_libdir}/xulrunner-%{version}/
%dir %{_libdir}/xulrunner-%{version}/chrome/
%dir %{_libdir}/xulrunner-%{version}/extensions/
%{_libdir}/xulrunner-%{version}/chrome/*.*
%{_libdir}/xulrunner-%{version}/chrome/icons/
%{_libdir}/xulrunner-%{version}/components/
%{_libdir}/xulrunner-%{version}/defaults/
%{_libdir}/xulrunner-%{version}/greprefs/
%{_libdir}/xulrunner-%{version}/icons/
%{_libdir}/xulrunner-%{version}/plugins/
%{_libdir}/xulrunner-%{version}/res/
%{_libdir}/xulrunner-%{version}/*.so
%{_libdir}/xulrunner-%{version}/LICENSE
%{_libdir}/xulrunner-%{version}/README.txt
%{_libdir}/xulrunner-%{version}/dependentlibs.list
%{_libdir}/xulrunner-%{version}/mozilla-xremote-client
%if !%has_system_nss
%{_libdir}/xulrunner-%{version}/libsoftokn3.chk
%endif
%{_libdir}/xulrunner-%{version}/run-mozilla.sh
%{_libdir}/xulrunner-%{version}/updater
%{_libdir}/xulrunner-%{version}/xpicleanup
%{_libdir}/xulrunner-%{version}/xulrunner
%{_libdir}/xulrunner-%{version}/xulrunner-bin
%{_libdir}/xulrunner-%{version}/xulrunner-stub
%{_libdir}/xulrunner-%{version}/javaxpcom.jar
%{_libdir}/xulrunner-%{version}/GenerateJavaInterfaces
%ghost %{_libdir}/xulrunner-%{version}/global.reginfo
%{_bindir}/xulrunner
# GRE
%dir %{_sysconfdir}/gre.d/
# example
%{_libdir}/xulrunner-%{version}/simple/

%files -n gecko-sdk
%defattr(-,root,root)
%{_libdir}/xulrunner-%{version}/*.a
%{_libdir}/xulrunner-%{version}/regxpcom
%{_libdir}/xulrunner-%{version}/xpidl
%{_libdir}/xulrunner-%{version}/xpt_dump
%{_libdir}/xulrunner-%{version}/xpt_link
%{_libdir}/xulrunner-%{version}/sdk/
%{_bindir}/xulrunner-config
%{_libdir}/pkgconfig/*
%{_includedir}/xulrunner-%{version}/

%changelog -n mozilla-xulrunner
* Fri Apr 21 2006 - stark@suse.de
- applied patch to be able to use proxy environment (#165891)
  (libunixproxy component)
- moved regxpcom to gecko-sdk
* Sun Mar 12 2006 - stark@suse.de
- another set of upstream patches (#148876)
* Sat Mar 04 2006 - stark@suse.de
- latest security fixes from upstream (#148876)
* Fri Feb 24 2006 - stark@suse.de
- dumpstack.patch is in upstream patch now
- more security/stability patches (#148876)
* Tue Feb 14 2006 - stark@suse.de
- applied a set of security patches (#148876)
* Tue Feb 07 2006 - stark@suse.de
- added extensions/ directory (#148716)
* Mon Jan 30 2006 - ro@suse.de
- reduced BuildRequires
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 23 2006 - stark@suse.de
- snapshot 1.8.0.1-20060122
* Wed Jan 18 2006 - stark@suse.de
- fixed DumpStackToFile for glibc 2.4
* Thu Jan 12 2006 - stark@suse.de
- bumped package version to 1.8.0.1
* Thu Jan 12 2006 - stark@suse.de
- update to snapshot 1.8.0-20060111
- added javaxpcom stuff
- use system NSS since CODE10
- use -fstack-protector where available
* Tue Dec 20 2005 - stark@suse.de
- update to snapshot 1.8-20051219
- reversioned to 1.8.0 to make clear that it's the
  stable 1.8.0 branch
* Tue Nov 22 2005 - stark@suse.de
- update to snapshot 1.8-20051121
- using rpath (#134536)
* Mon Nov 07 2005 - stark@suse.de
- update to snapshot 1.8-20051106
- added nsISidebar (bmo #315346) and nsIPermission (bmo #315345)
  to fix epiphany and others (#129619)
* Fri Oct 28 2005 - stark@suse.de
- update to snapshot 1.8-20051027
- added bugfix for system-prefs (bmo #313962)
- fixed init of gtkmozembed (bmo #314138)
* Wed Oct 12 2005 - stark@suse.de
- ship again all headers with subdirs together with the base ones
* Tue Oct 11 2005 - stark@suse.de
- moved header files in gecko-sdk
* Tue Oct 11 2005 - stark@suse.de
- update to snapshot 1.8b5-20051010
* Wed Sep 28 2005 - stark@suse.de
- update to snapshot 1.8b4-20050927
- use system NSPR and system cairo in PLUS
- removed obsolete API patch (in-tree cairo 1.0.0)
* Thu Sep 22 2005 - stark@suse.de
- update to snapshot 1.8b4-20050921
- added cairo API fix
- fixed build with new gcc
* Fri Aug 26 2005 - stark@suse.de
- update to snapshot 1.8-20050825
- enabled pango font rendering
  * fixed pango for GTK 2.8 (pango-cairo.patch)
* Tue Aug 23 2005 - stark@suse.de
- update to snapshot 1.8-20050822
  (internal cairo doesn't fit our pango)
- use system cairo
  * fixed canvas build for system cairo
- don't provide NSS libs for SUSE releases > 9.3
- added PreReq for registration stuff in install scripts
- fixed registration order for updates
- removed no-strip.patch as it is done in spec
* Tue Jul 05 2005 - stark@suse.de
- update to snapshot 20050704
- fixed optimization for NSS component
- fixed requirements for SDK package
* Mon Jun 20 2005 - stark@suse.de
- update to snapshot 20050619 (fixes IA64 build)
- added GRE stuff
* Sat Jun 11 2005 - stark@suse.de
- enabled HTML Canvas
- update to snapshot 20050610
- make debuginfo packages usable
* Mon Mar 21 2005 - stark@suse.de
- initial package
